//+------------------------------------------------------------------+
//|                                                   MA Candles.mq4 |
//|                                              Code adapted by cja |
//+------------------------------------------------------------------+

#property copyright      "Code adapted by cja"

//---- indicator settings
#property  indicator_chart_window

#property indicator_buffers 4
#property indicator_color1 RoyalBlue//wicks
#property indicator_color2 Red//wicks
#property indicator_color3 RoyalBlue
#property indicator_color4 Red

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3
//MODE_SMA 0 Simple moving average, 
//MODE_EMA 1 Exponential moving average, 
//MODE_SMMA 2 Smoothed moving average, 
//MODE_LWMA 3 Linear weighted moving average. 

//PRICE_CLOSE 0 Close price. 
//PRICE_OPEN 1 Open price. 
//PRICE_HIGH 2 High price. 
//PRICE_LOW 3 Low price. 
//PRICE_MEDIAN 4 Median price, (high+low)/2. 
//PRICE_TYPICAL 5 Typical price, (high+low+close)/3. 
//PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 


//---- indicator parameters
extern string IIIIIIIIIIIIIIIIIIIII=">>> MA Settings >>>>>>>>>>>>>>>>>";
extern int	    MA1		= 5.0;
extern int      MA2		= 25.0;
extern ENUM_MA_METHOD      MA1_MODE		= 0;
extern ENUM_MA_METHOD      MA2_MODE		= 0;
extern ENUM_APPLIED_PRICE  MA1_PRICE		= 0;
extern ENUM_APPLIED_PRICE  MA2_PRICE		= 0;
extern int      MA1_SHIFT     = 0;
extern int      MA2_SHIFT     = 0;

extern string IIIIIIIIIIIIIIIIIIIIIIIII=">>> Candle/Wick Display Settings >>>>>>>>>>>>>>>>>";		 
extern int		BarWidth			= 1,
					CandleWidth		= 3;
					
extern bool Show_Comment = true;						
extern bool   alertsOn               = False;    // Turn alerts on?
extern bool   alertsOnCurrentBar     = true;     // Alerts on current (stil opened) bar?
extern bool   alertsMessage          = true;     // Alerts should show popup message?
extern bool   alertsSound            = false;    // Alerts should play alert sound?
extern bool   alertsEmail            = false;    // Alerts shouls send email?
extern bool   alertsPush             = false;    // Alerts shouls send push notification?


//---- indicator buffers
double Bar1[],
		 Bar2[],
		 Candle1[],
		 Candle2[],
		 state[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {


   IndicatorShortName("MA Candles");
	IndicatorBuffers(5);
	
	SetIndexBuffer(0,Bar1);
	SetIndexBuffer(1,Bar2);
	SetIndexBuffer(2,Candle1);
	SetIndexBuffer(3,Candle2);				
	SetIndexBuffer(4,state);				
	
	SetIndexStyle(0,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth);
	SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth);
	
	SetIndexLabel(0, "MA"+MA1+" + MA"+MA2);
   SetIndexLabel(1, "MA"+MA1+" + MA"+MA2);
   SetIndexLabel(2, "MA"+MA1+" + MA"+MA2);
   SetIndexLabel(3, "MA"+MA1+" + MA"+MA2);
   return(0);
  }
  
  int deinit()
  {
   return(0);
  }
 
int start()
{
   int i,counted_bars = IndicatorCounted();
      if(counted_bars<0) return(0);
      if(counted_bars>0) counted_bars--;   
           int limit=MathMin(Bars-counted_bars,Bars-1);
           
	for(i = limit; i>=0; i--)
	{
		double	Ma1	= iMA(NULL,0,MA1,MA1_SHIFT,MA1_MODE, MA1_PRICE,i);
		double	Ma2	= iMA(NULL,0,MA2,MA2_SHIFT,MA2_MODE, MA2_PRICE,i);

		double bodyHigh = MathMax(Open[i],Close[i]);
		double bodyLow  = MathMin(Open[i],Close[i]);
		double high		 = High[i];
		double low		 = Low[i];
	

	   Bar1[i] = low;	Candle1[i] = bodyLow;
	   Bar2[i] = low;	Candle2[i] = bodyLow;

		if(Ma1 > Ma2) { Bar1[i] = high; Candle1[i] = bodyHigh;  state[i]= 1;}
		if(Ma1 < Ma2) { Bar2[i] = high; Candle2[i] = bodyHigh;  state[i]=-1;}
		
  }
  manageAlerts();
   string Label1="",Label2="";      
      if(MA1_MODE==0) Label1="MA";   if(MA2_MODE==0) Label2="MA";
      if(MA1_MODE==1) Label1="EMA";  if(MA2_MODE==1) Label2="EMA";
      if(MA1_MODE==2) Label1="SMMA"; if(MA2_MODE==2) Label2="SMMA";
      if(MA1_MODE==3) Label1="LWMA"; if(MA2_MODE==3) Label2="LWMA";
//      if(Show_Comment) Comment("\n","MA Candles  "+Label1+" "+MA1+"  &  "+Label2+ " "+MA2+""); 
      return(0);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrentBar) whichBar = 0;
      Comment(state[whichBar],"    ",state[whichBar+1]);
      if (state[whichBar] != state[whichBar+1])
      {
            if (state[whichBar] == 1) doAlert(whichBar," ma candles state changed to up");
            if (state[whichBar] ==-1) doAlert(whichBar," ma candles state changed to down");
      }         
   }
}   

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  _Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(_Symbol+" ma candles",message);
             if (alertsPush)    SendNotification(message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}
